#ifndef TYPE_H
#define TYPE_H 1

typedef struct { 
	int	A[maxdim + 1]; 
	unsigned short int length; // added by FB&FT 20060301 to take care of
				// zeros...
}	frame;

typedef struct { frame	A[maxdimqframe - 1 + 1]; }	qframe;
typedef struct { int	A[maxl + 1]; }	bframe;
typedef struct { int	A[maxdim + 1]; }	lbframe;
typedef struct { int	A[maxlen + 1]; }	arr;
typedef struct { int	A[maxsize + 1]; }	barr;
typedef frame *	arrayptr;
typedef struct { char	A[brtabmax - 1 + 1]; }	smalltab;
typedef struct { char	A[bcol - 1 + 1]; }	string0;

typedef enum { rrow, ccol, rc } 	hktype;
typedef enum { norm, pe6, e6bra, prod,
	triple } 	caystype;
typedef enum { sung, un, son, on,
	spn, sn, an, g2,
	f4, en, e6, e7,
	e8, ospnm, unm, nill,l168,
	sunm, spnc, mp,sonc,unc} 	grptype;
typedef enum { sfnm, brm, repm, dpm } 	modes;

//for sfn
typedef struct term {	// was S62
	struct term	*next; // must be in first place
	int	mult;
	frame	val;
	char	slab;   // ' ' or '#'
}	term; 
typedef term * termptr;
typedef struct { termptr	A[maxdim + 1]; }	termarray;

//for repmode (and encapsulated by dpmode)
typedef struct ocharac {  // was S63
	struct ocharac	*next; // must be in first place
	int	mult;
	frame	val;
	char	lab;   // can be ' ', '+', '-' or '#'
	bool	spin;
	bool	C6_double;// seems to mean : if true conval and conlab are used.
	frame	conval;
	char	conlab;
}	ocharac;
typedef ocharac * ocharptr;

typedef struct groop { // was S240
	grptype	name;
	int	rank;
	int	rank2;
}	groop;
typedef struct  { groop	A[maxprod - 1 + 1]; }	groopArray;

//for dpmode
typedef struct prodrec {  // was S64
	struct prodrec	*next; // must be in first place
	struct { ocharptr	A[maxprod - 1 + 1]; }	prods;
	int	mult;
}	prodrec;
typedef prodrec * prodtype;

typedef struct fns {   // was S65
	string0	gbuff;
	struct fns  *next;
}	fns;
typedef fns *fnptrs;

typedef struct branchtab {  // was S66
	smalltab	tab;
}	branchtab;
typedef branchtab *tabptr;

typedef unsigned char	byte;

typedef struct { 
  struct { int	A[worksize - 1 + 1]; }	A[maxdim + 1]; 
}	Tableau;
typedef struct { 
  termptr	A[segptrmax - 1 + 1]; 
}	Tab_Segptr;

struct { fnptrs	A[maxfn - 1 + 1]; }	fn;

// Variables (sfn mode, repmode, dpmode)
struct { termptr	A[svarlimit - 1 + 1]; }	svar;
struct { ocharptr	A[varlimit - 1 + 1]; }	vari;
struct { prodtype	A[pvarlimit - 1 + 1]; }	pvar;

// memory management: keep an eye on what to clean after computation 
// of a command line (see stackhandle(), collectgarbage()
struct { prodtype	A[prjctlimit - 1 + 1]; }	preject;
struct { ocharptr	A[rjctlimit - 1 + 1]; }		reject;
struct { ocharptr	A[rjctlimit - 1 + 1]; }		reject2;
struct { termptr	A[srjctlimit - 1 + 1]; }	sreject;

// these sets are used to accelerate the checks on special characters
struct { setword	S[9]; }	brackets, plus_minus_etc, numbers, letterset;

#endif /* ! TYPE_H */
